// SMSPlusInjector.cpp : SMS Plus DOL maker
//

#include <iostream.h>
#include <fstream.h>

int main(int argc, char* argv[])
{
	char copy;

	cout << "SMS Plus for Gamecube DOL creator" << endl;

	if(argc <= 1){
		cout << "No arguments provided. Please pass the filename of a MasterSystem/GameGear ROM." << endl;
	}
	else{
		int chunk;
		int temp;
		ifstream romfile;
		ifstream datafile;
		ofstream outfile;

		char outfilename[64];
		
		int romsize = 0;

		romfile.open(argv[1],ios::in | ios::binary);
		datafile.open("smsplus.bin",ios::in | ios::binary);

		if(datafile.peek() == EOF){
			cout << "Run this from the command prompt!" << endl;
			return 0;
		}

		cout << "Enter a filename for the output DOL: (Example: smsplus.dol)" << endl;
		cin >> outfilename;

		outfile.open(outfilename,ios::out | ios::binary);
		
		//Perform copy and bytesetup
		//Data file format:
		//First 4 bytes are the header
		//0x00 - 4 byte file beginning chunk size
		datafile.get(copy);
		chunk = (copy & 0xFF) << 24;
		datafile.get(copy);
		chunk += (copy & 0xFF) << 16;
		datafile.get(copy);
		chunk += (copy & 0xFF) << 8;
		datafile.get(copy);
		chunk += (copy & 0xFF);

		for(temp=0; temp<chunk; temp++){
			//Copy DOL header
			datafile.get(copy);
			outfile.put(copy);

			if (datafile.peek() == EOF){
				datafile.close();
				romfile.close();
				outfile.close();
				cout << "There was an error in the data file. The DOL can not be created." << endl;
				return 0;
			}
		}

		//Copy Rom and generate checksum
		while(romfile.peek() != EOF){
			romfile.get(copy);
			outfile.put(copy);
			romsize++;

			if (romsize == 0x400000)
				break;
			//Shit, this rom is too big.
		}

		temp=0;
		while(romsize+temp < 0x80000){
			outfile.put(char(0xFF));
			temp++;
		}

		//Copy Post ROM data
		while(datafile.peek() != EOF){
			datafile.get(copy);
			outfile.put(copy);
		}
		
		cout << outfilename << " has been created successfully." << endl;
		
		datafile.close();
		romfile.close();
		outfile.close();
	}

	return 0;
}

